/* Asynchronous read.
   Copyright (C) 1997, 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   Contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <aio.h>

#include "aio_misc.h"
#include <errno.h>


int
aio_read (aiocbp)
     struct aiocb *aiocbp;
{
  /* If invalid aiocbp, file descriptor or offset: set error & exit */
  if(aiocbp == NULL || aiocbp->aio_fildes < 0) 
    {
       __set_errno(EBADF);
       return -1;
    }
  if(aiocbp->aio_offset < 0 || aiocbp->aio_buf == NULL) 
    {
       __set_errno(EINVAL);
       return -1;
    }
  return (__aio_enqueue_request ((aiocb_union *) aiocbp, LIO_READ) == NULL
	  ? -1 : 0);
}
